/*
 * @OSF_FREE_FREE_COPYRIGHT@
 * 
 */
/*
 * HISTORY
 * $Log: ksyms.c,v $
 * Revision 1.1.2.4  1997/06/03  15:20:18  barbou
 * 	Merged up to linux-2.0.30.
 * 	[1997/06/03  15:17:24  barbou]
 *
 * Revision 1.1.2.3  1997/01/24  16:57:58  barbou
 * 	Merged up to linux-2.0.26.
 * 	[1997/01/24  14:50:58  barbou]
 * 
 * Revision 1.1.2.2  1996/09/27  22:30:05  barbou
 * 	Merged up to linux-2.0.21.
 * 	[1996/09/27  22:01:18  barbou]
 * 
 * Revision 1.1.2.1  1996/09/09  16:17:44  barbou
 * 	Created.
 * 	[1996/09/03  14:37:41  barbou]
 * 
 * $EndLog$
 */

#include <linux/module.h>
#include <linux/smp.h>
#include <linux/user.h>
#include <linux/elfcore.h>

#include <asm/semaphore.h>

extern void dump_thread(struct pt_regs *, struct user *);
extern int dump_fpu(elf_fpregset_t *);

static struct symbol_table arch_symbol_table = {
#include <linux/symtab_begin.h>
	/* platform dependent support */
	X(dump_thread),
	X(dump_fpu),
	XNOVERS(down_failed),
	XNOVERS(down_failed_interruptible),
	XNOVERS(up_wakeup),
#ifdef __SMP__
	X(apic_reg),		/* Needed internally for the I386 inlines */
	X(cpu_data),
	X(syscall_count),
	X(kernel_flag),
	X(kernel_counter),
	X(active_kernel_processor),
	X(smp_invalidate_needed),
#endif
#include <linux/symtab_end.h>
};

void arch_syms_export(void)
{
	register_symtab(&arch_symbol_table);
}
