/*
 * @OSF_FREE_FREE_COPYRIGHT@
 * 
 */
/*
 * HISTORY
 * $Log: elf.h,v $
 * Revision 1.1.2.1  1997/02/27  11:10:54  bruel
 * 	First revision
 * 	[1997/02/27  11:01:16  bruel]
 *
 * $EndLog$
 */

#ifndef __HPPA_ELF_H
#define __HPPA_ELF_H

/*
 * ELF register definitions..
 */

#define ELF_NGREG	64
#define ELF_NFPREG	32

typedef unsigned long elf_greg_t;
typedef elf_greg_t elf_gregset_t[ELF_NGREG];

typedef double elf_fpreg_t;
typedef elf_fpreg_t elf_fpregset_t[ELF_NFPREG];

/*
 * This is used to ensure we don't load something for the wrong architecture.
 */
#define elf_check_arch(x) ((x) == EM_PARISC) 

/*
 * These are used to set parameters in the core dumps.
 */
#define ELF_CLASS	ELFCLASS32
#define ELF_DATA	ELFDATA2MSB;
#define ELF_ARCH	EM_PARISC

#define ELF_EXEC_PAGESIZE	4096


#endif
