/*
 * @OSF_FREE_FREE_COPYRIGHT@
 * 
 */
/*
 * HISTORY
 * $Log: ptrace.h,v $
 * Revision 1.1.2.3  1996/11/05  15:38:43  barbou
 * 	Adapted to the split pt_regs structure.
 * 	[96/11/05            barbou]
 *
 * Revision 1.1.2.2  1996/09/27  22:55:09  barbou
 * 	Merged up to linux-2.0.21.
 * 	[1996/09/27  22:11:09  barbou]
 * 
 * Revision 1.1.2.1  1996/09/18  14:23:33  barbou
 * 	Added INIT_PTREGS definition.
 * 	Define KERNEL to get show_regs prototype.
 * 	[96/09/11            barbou]
 * 
 * 	Created.
 * 	[1996/09/11  17:00:42  barbou]
 * 
 * $EndLog$
 */

#ifndef _ASM_OSFMACH3_PPC_PTRACE_H
#define _ASM_OSFMACH3_PPC_PTRACE_H

#ifdef	__KERNEL__
#define KERNEL
#endif

#include <asm-ppc/ptrace.h>

#define pt_extra_regs	_pad

#ifdef	PPC_DEBUG
#define INIT_PTREGS_DEBUG \
	0, 0,					/* hash1, hash2 */ \
	0, 0,					/* imiss, dmiss */ \
	0, 0,					/* icmp, dcmp */ \
	0,					/* marker */ \
	0,					/* edx */
#else	/* PPC_DEBUG */
#define INIT_PTREGS_DEBUG
#endif	/* PPC_DEBUG */

#define INIT_PTREGS { \
	0,					/* nip */ \
	0,					/* msr */ \
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
	  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
	  0 , 0 },				/* gpr[32] */ \
	0,					/* ccr */ \
	0,					/* xer */ \
	0,					/* link */ \
	0,					/* ctr */ \
	0,					/* mq */ \
	0,					/* _pad */ \
	/* start of "extra registers" */ \
	0,					/* dar */ \
	0,					/* dsisr */ \
	0,					/* orig_gpr3 */ \
	0,					/* result */ \
	{ 0.0, 0.0, 0.0, 0.0 },			/* fpr[4] */ \
	0.0,					/* fpcsr */ \
	0,					/* trap */ \
	INIT_PTREGS_DEBUG \
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
	  0, 0, 0, 0, 0, 0, 0 }			/* _underhead[20] */ \
}

#endif	/* _ASM_OSFMACH3_PPC_PTRACE_H */
