#ifndef _ASM_PPC_SEGMENT_H
#define _ASM_PPC_SEGMENT_H

#include <linux/string.h>

#define put_user(x,ptr) __put_user((unsigned long)(x),(ptr),sizeof(*(ptr)))
#define get_user(ptr) ((__typeof__(*(ptr)))__get_user((ptr),sizeof(*(ptr))))
#define get_fs_byte(addr) get_user_byte((char *)(addr))
#define get_fs_word(addr) get_user_word((short *)(addr))
#define get_fs_long(addr) get_user_long((int *)(addr))
#define put_fs_byte(x,addr) put_user_byte((x),(char *)(addr))
#define put_fs_word(x,addr) put_user_word((x),(short *)(addr))
#define put_fs_long(x,addr) put_user_long((x),(int *)(addr))
#define memcpy_fromfs(to, from, n) memcpy((to),(from),(n))
#define memcpy_tofs(to, from, n) memcpy((to),(from),(n))

/*
 * For segmented architectures, these are used to specify which segment
 * to use for the above functions.
 *
 * The powerpc is not segmented, so these are just dummies.
 */

#define KERNEL_DS 0
#define USER_DS 1

#define get_fs() 0
#define get_ds() 0
#define set_fs(x)

#endif /* _ASM_SEGMENT_H */
