/*
 * 
 * $Copyright
 * Copyright 1991 Intel Corporation
 * INTEL CONFIDENTIAL
 * The technical data and computer software contained herein are subject
 * to the copyright notices; trademarks; and use and disclosure
 * restrictions identified in the file located in /etc/copyright on
 * this system.
 * Copyright$
 * 
 */
 
/*
 * Copyright 1996 1995 by Open Software Foundation, Inc. 1997 1996 1995 1994 1993 1992 1991  
 *              All Rights Reserved 
 *  
 * Permission to use, copy, modify, and distribute this software and 
 * its documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appears in all copies and 
 * that both the copyright notice and this permission notice appear in 
 * supporting documentation. 
 *  
 * OSF DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE. 
 *  
 * IN NO EVENT SHALL OSF BE LIABLE FOR ANY SPECIAL, INDIRECT, OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM 
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, 
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION 
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */
/*
 * MkLinux
 */
/* CMU_HIST */
/*
 * Revision 2.6.2.3  92/05/27  00:41:36  jeffreyh
 * 	sjs@osf.org pointed out that some debugging code in a stack
 * 	boundary check had the relational operators reversed.  Whoops!
 * 	[92/04/26	andyp@ssd.intel.com]
 * 	Support floating point exceptions.
 * 	sjs assert() code.
 * 	[92/04/26	stans@ssd.intel.com]
 * 
 * Revision 2.6.2.1  92/03/28  10:08:07  jeffreyh
 * 	r0, f0, f1 fixes; sanity check psr
 * 	[92/03/20            andyp]
 * 
 * Revision 2.6  91/12/10  16:30:54  jsb
 * 	Fixes from Intel
 * 	[91/12/10  15:32:50  jsb]
 * 
 * Revision 2.5  91/08/28  11:12:20  jsb
 * 	From Intel SSD: various fixes. Added pcb_get{cur,th}pcb for cswitch.s.
 * 	[91/08/26  17:01:02  jsb]
 * 
 * Revision 2.4  91/06/18  20:51:36  jsb
 * 	New copyright from Intel.
 * 	[91/06/18  18:57:14  jsb]
 * 
 * Revision 2.3  91/06/17  15:44:58  jsb
 * 	Added stack_attach, stack_detach, etc. for continuation support.
 * 	[91/06/17  10:13:46  jsb]
 * 
 * Revision 2.2  90/12/04  14:49:00  jsb
 * 	First checkin.
 * 	[90/12/03  21:31:38  jsb]
 * 
 */
/* CMU_ENDHIST */
/* 
 * Mach Operating System
 * Copyright (c) 1991 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
/*
 * Copyright 1988, 1989, 1990, 1991 by Intel Corporation,
 * Santa Clara, California.
 * 
 *                          All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appears in all copies and that
 * both the copyright notice and this permission notice appear in
 * supporting documentation, and that the name of Intel not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * INTEL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT
 * SHALL INTEL BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE, OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
/*
 * pcb.c,v 2.31 1994/10/19 01:41:41 lenb Exp
 */

#include <cpus.h>
#include <mach_kdb.h>
#include <mach_assert.h>
#include <db_machine_commands.h>
#include <osf_intel.h>

#include <mach/thread_status.h>
#include <mach/kern_return.h>
#include <mach/boolean.h>

#include <kern/counters.h>
#include <kern/thread.h>
#include <kern/thread_swap.h>
#include <kern/mach_param.h>
#include <ipc/ipc_port.h>
#include <mach/vm_param.h>
#include <i860/thread.h>
#include <i860/psl.h>
#include <i860/setjmp.h>
#include <i860/cpu_master.h>

#include <i860/fpe/fpe.h>

#if	MACH_KDB
#include <ddb/db_sym.h>
#endif	MACH_KDB

#if	PARAGON860
#if	OSF_INTEL
#include <i860/PARAGON/baton.h>
#else	/* OSF_INTEL */
#include <i860paragon/baton.h>
#endif	/* OSF_INTEL */
#endif	PARAGON860

/* This is the number of bytes above an initial kernel stack  */
#define I860_STACK_COOKIES	(sizeof(struct i860_exception_link) + \
			sizeof(struct i860_kernel_state))

/* keep the pcb's aligned on this boundary */
#define ALIGNMENT	16

/* top of the kernel stack */
#define TOPOF(base)	(((base)+KERNEL_STACK_SIZE - I860_STACK_COOKIES) & ~0xf)

/*
 * Maps state flavor to number of words in the state:
 *
 * N.B. i860_PIPE_STATE_COUNT and i860_XP_STATE_COUNT are
 *	conditionalized under NOT_YET in ./mach/i860/thread_status.h
 */
unsigned int state_count[] = {
	/* FLAVOR_LIST */ 0,
	i860_THREAD_STATE_COUNT,
	/* i860_PIPE_STATE_COUNT */ 0,
	/* i860_XP_STATE_COUNT */ 0,
	i860_SAVED_STATE_COUNT,
};

/* cache debugging */
#if	NOCACHE
#if     PARAGON860
int     flush_on_syscall_return = 1;
int     flush_on_exception_return = 1;
int     flush_on_bootstrap_return = 1;
#else   PARAGON860
int	flush_on_syscall_return = 0;
int	flush_on_exception_return = 0;
int	flush_on_bootstrap_return = 0;
#endif  PARAGON860
#else	NOCACHE
#if     PARAGON860
int     flush_on_syscall_return = 0;
int     flush_on_exception_return = 0;
int     flush_on_bootstrap_return = 0;
#else   PARAGON860
int	flush_on_syscall_return = 0;
int	flush_on_exception_return = 0;
int	flush_on_bootstrap_return = 0;
#endif  PARAGON860
#endif	NOCACHE

/*
 *	Interrupt handling debugging.
 */
#define	INTERRUPT_DEBUG	0
#if	INTERRUPT_DEBUG
extern int	interrupt_nesting_level[NCPUS];
#endif	/* INTERRUPT_DEBUG */

/*
 *	Default policy for misaligned accesses.
 */
int	i860_misalignment_policy = 1;	/* 1=signal, 0=handle */

void		change_address_space(thread_act_t, thread_act_t);

vm_offset_t	kernel_stack[NCPUS];
pcb_t		current_pcb[NCPUS];

#define	PARANOIDPCB	0	/* track thread in ks->ks_r0 */
#define	PREFAULT_PC	0	/* XXX copyin(*(fir-4)...) workaround XXX */

/* install thread "th" the current thread */

#ifdef	ASMP
#define INSTALL_THREAD(th)					\
	{ register int cpu = cpu_number(), s = sploff();	\
	struct thread *old_thread = cpu_data[cpu].active_thread; \
	cpu_data[cpu].active_thread = (th);			\
	baton_handoff(old_thread, (th));			\
	MACHINE_STACK_STASH((th)->kernel_stack);		\
	current_pcb[cpu] = (th)->top_act->mact.pcb;		\
	splon(s);						\
	}
#else	ASMP
#define INSTALL_THREAD(th)					\
	{ register int cpu = cpu_number(), s = sploff();	\
	cpu_data[cpu].active_thread = (th);			\
	MACHINE_STACK_STASH((th)->kernel_stack);		\
	current_pcb[cpu] = (th)->top_act->mact.pcb;		\
	splon(s);						\
	}
#endif	ASMP


#if	MACH_KDB && MACH_ASSERT && DB_MACHINE_COMMANDS

#define	SWITCH_HISTORY	1
#if	SWITCH_HISTORY

#define	SWITCH_HISTLEN	32

struct switch_history {
	unsigned int	sh_flag;	/* what kind of record */
	unsigned long	sh_nth;		/* nth call to switch_context() */
	unsigned long	sh_trapn;	/* nth ctrap */
	unsigned long	sh_astn;	/* nth ast */
	thread_act_t	sh_curact;	/* current_act() */
	vm_offset_t	sh_cursp;	/* current_stack() */
	thread_t	sh_old;		/* old thread */
	int		sh_old_state;	/* old thread's state */
	vm_offset_t	sh_old_kstack;	/* old thread's kernel stack */
	void		(*sh_cont)();	/* continuation for old thread */
	thread_t	sh_new;		/* new thread */
	int		sh_new_state;	/* new thread's state */
	vm_offset_t	sh_new_kstack;	/* new thread's kernel stack */
	unsigned long	sh_r1;		/* new thread's kernel regs */
	unsigned long	sh_sp;		/* new thread's kernel regs */
	unsigned long	sh_fp;		/* new thread's kernel regs */
};
unsigned long switch_context_total;
int	switch_history_next;
int	switch_history_enabled = 0;
static struct switch_history switch_history[SWITCH_HISTLEN];

#define	LOG_SWITCH	0
#define	LOG_HANDOFF	1
#define LOG_ATTACH	2
#define LOG_DETACH	3
#define LOG_CONTINUE	4
#define LOG_SYSCALLRET	5
#define LOG_EXCEPTRET	6
#define LOG_BOOTRET	7

/*
 *	runtime patchable...
 */
#define switch_log(meth,old,cont,new,newks)	\
	if (switch_history_enabled) _switch_log(meth,old,cont,new,newks)

static void _switch_log(method, old, continuation, new, newks)
int		method;
thread_t	old;
void		(*continuation)();
thread_t	new;
struct i860_kernel_state *newks;
{
	struct switch_history *sh;

	extern unsigned long	taken_ast_count;
        thread_act_t new_act = new->top_act;
        thread_act_t old_act = old->top_act;

	sh = &switch_history[switch_history_next++];
	if (switch_history_next >= SWITCH_HISTLEN)
		switch_history_next = 0;

	sh->sh_flag = method;
	sh->sh_nth = switch_context_total++;
 
	sh->sh_trapn = 0;	/* recorded per-cpu in rpmsoft, see rpm.h */
	sh->sh_astn = taken_ast_count;
	sh->sh_curact = current_act();
#if 0	/* code from sjs */
	sh->sh_cursp = new ?  USER_REGS(new_act)->sp : current_stack ();
	if (new && sh->sh_cursp == 0)   /* only happens if sp unassigned */
		sh->sh_cursp = (vm_offset_t)USER_REGS(new_act);
#else
	sh->sh_cursp = current_stack();
#endif
	sh->sh_old = old;
	sh->sh_old_state = old->state;
	sh->sh_old_kstack = old->kernel_stack;
	sh->sh_new = new;

	switch (method) {
	case LOG_SWITCH:
		sh->sh_new_state = new->state;
		sh->sh_new_kstack = new->kernel_stack;
		sh->sh_cont = continuation;
		sh->sh_r1 = newks->ks_r1;
		sh->sh_sp = newks->ks_sp;
		sh->sh_fp = newks->ks_fp;
		break;

	case LOG_HANDOFF:
		sh->sh_new_state = new->state;
		sh->sh_new_kstack = new->kernel_stack;
		break;

	case LOG_ATTACH:
	case LOG_CONTINUE:
		sh->sh_cont = continuation;
	case LOG_DETACH:
	case LOG_SYSCALLRET:
	case LOG_EXCEPTRET:
	case LOG_BOOTRET:
		break;
	}
}
#endif	/* SWITCH_HISTORY */

#else	/* MACH_KDB && MACH_ASSERT && DB_MACHINE_COMMANDS */

#define	switch_log(method, thread, continuation, a, b)

#endif	/* MACH_KDB && MACH_ASSERT && DB_MACHINE_COMMANDS */

#if	!OSF_INTEL
/*
 *	From: Andy Pfiffer, Intel SSD
 *	Big-time overhaul for i860 stack handoff support.
 *
 *	Block comments above some of the functions were copied
 *	from the descriptions given in:
 *
 *		"Using Continuations to Implement Thread Management
 *		 and Communication in Operating Systems",
 *		R. Draves, B. Bershad, R. Rashid, R. Dean.
 */

/*
 *	stack_attach:
 *
 *	Transforms a machine-independent continuation into a machine-
 *	dependent kernel stack, attaching the kernel stack to the thread
 *	and initializing the stack so that when switch_context() resumes
 *	the thread, control transfers to the supplied continuation function
 *	with the previously running thread as an argument.
 *
 */
void stack_attach(thread, stack, continuation)
	thread_t	thread;
	vm_offset_t	stack;
	void		(*continuation)();
{
	register struct i860_kernel_state *ks;

	counter(if (++c_stacks_current > c_stacks_max)
			c_stacks_max = c_stacks_current);

	assert(stack != (vm_offset_t) 0);
	assert(thread->kernel_stack == (vm_offset_t) 0);
	assert(continuation != (void (*)()) 0);
	assert(thread != current_thread());

#if	MACH_ASSERT
	{
		int		dummy;
		static int	inrange();

		if (current_stack() && !inrange(&dummy, current_stack())) {
			printf("stack_attach(th=0x%x,stack=0x%x,cont=0x%x):\n",
				thread, stack, continuation);
			printf("&dummy = 0x%x\n", &dummy);
			printf("[0x%x to 0x%x]\n",
				current_stack(),
				current_stack() + KERNEL_STACK_SIZE);
			assert(0);
		}
	}
#endif	MACH_ASSERT

	thread->kernel_stack = stack;

	ks = STACK_IKS(stack);

#if	PARANOIDPCB
	/*
	 *	XXX the following assertion can falsely trigger
	 *	XXX when given a brand-new stack when
	 *	XXX stack_alloc() calls kmem_alloc_aligned()
	 *	XXX or when stack_check_usage == TRUE.
	 */
	/*assert(ks->ks_r0 == 0);*/
	if (ks->ks_r0 != 0) {
#if	0
		printf("stack_attach(th=0x%x,st=0x%x,cont=0x%x):\n",
			thread, stack, continuation);
		printf("    ks=0x%x, ks->ks_r0 == 0x%x\n", ks, ks->ks_r0);
#endif	0
	}
	ks->ks_r0 = (unsigned) thread;
#endif	PARANOIDPCB

	ks->ks_r1 = (unsigned) continuation;
	ks->ks_sp = (unsigned) TOPOF(stack);
	ks->ks_fp = 0;

	STACK_IEL(stack)->eframe = USER_REGS(thread);

	switch_log(LOG_ATTACH, thread, continuation, 0, 0);
}


/*
 *	stack_detach:
 *
 *	Detaches and returns the thread's kernel stack.
 *
 */
vm_offset_t stack_detach(thread)
	register thread_t	thread;
{
	register vm_offset_t	stack;

	counter(if (--c_stacks_current < c_stacks_min)
			c_stacks_min = c_stacks_current);

	assert(thread != current_thread());
	assert(thread->kernel_stack != current_stack());
	assert(thread->kernel_stack != (vm_offset_t) 0);

	stack = thread->kernel_stack;
	thread->kernel_stack = 0;

#if	PARANOIDPCB
	{
		register struct i860_kernel_state *ks;

		ks = STACK_IKS(stack);
		assert(ks->ks_r0 == (unsigned) thread);
		ks->ks_r0 = 0;
	}
#endif	PARANOIDPCB

	switch_log(LOG_DETACH, thread, 0, 0, 0);
	return stack;
}


/*
 *	stack_handoff:
 *
 *	Does a stack handoff, moving the current kernel stack from the
 *	current thread to the new thread.  stack_handoff() changes
 *	address spaces if necessary.  stack_handoff() returns as the
 *	new thread.
 */
void stack_handoff(old, new)
	register thread_t	old;
	register thread_t	new;
{
	register vm_offset_t	stack;

	assert(get_spl() > 0);
	assert(old == current_thread());
	assert(old->kernel_stack == current_stack());
	assert(old->kernel_stack != (vm_offset_t) 0);
	assert(USER_REGS(old) == (STACK_IEL(old->kernel_stack)->eframe));
	assert(new->kernel_stack == (vm_offset_t) 0);

	stack = old->kernel_stack;
	new->kernel_stack = stack;
	old->kernel_stack = (vm_offset_t) 0;

#if	PARANOIDPCB
	{
		register struct i860_kernel_state *ks;

		ks = STACK_IKS(stack);
		assert(ks->ks_r0 == (unsigned) old);
		ks->ks_r0 = (unsigned) new;
	}
#endif	PARANOIDPCB

	if (old->task != new->task)
		change_address_space(old, new);

	INSTALL_THREAD(new);

	STACK_IEL(stack)->eframe = USER_REGS(new);

	switch_log(LOG_HANDOFF, old, 0, new, 0);
}

#endif	/* !OSF_INTEL */

/*
 *	call_continuation:
 *
 *	Calls the supplied continuation, resetting the current kernel
 *	stack pointer to the base of the stack.  This function
 *	prevents stack overflow during a long sequence of continuation
 *	calls.
 */
void call_continuation(continuation)
	void	(*continuation)();
{

	vm_offset_t	stack;
	thread_t	th;

	th = current_thread();
	stack = current_stack();

	assert(get_psr() & 0x10);	/* interrupts enabled */
#if	MACH_ASSERT
	/*assert(get_spl() == 0);*/
	if (get_spl() != 0) {
		printf("mk warning: call_continuation: spl=%d\n", get_spl());
	}
#endif	MACH_ASSERT

	assert(th != (thread_t) 0);
	assert(stack != (vm_offset_t) 0);
	assert(stack == th->kernel_stack);
	assert(STACK_IEL(stack)->eframe == USER_REGS(th->top_act));

#if	PARANOIDPCB
	assert(STACK_IKS(stack)->ks_r0 == (unsigned) th);
#endif	PARANOIDPCB

	switch_log(LOG_CONTINUE, th, continuation, 0, 0);

	i860_call_continuation_new(continuation, TOPOF(stack), USER_REGS(th->top_act));
	/*NOTREACHED*/
}


void
act_machine_switch_pcb(
	thread_act_t	new)
{
	/*
	 * "All" we need to do is context switch to the new
	 * activation...
	 */
}

void load_context(new)
	thread_t	new;
{
	INSTALL_THREAD(new);
	i860_context_load(STACK_IKS(new->kernel_stack), 0);
	/*NOTREACHED*/
}


#if	MACH_ASSERT
static int inrange(addr, base)
vm_offset_t	addr, base;
{
	return ((addr > base) && (addr < (base + KERNEL_STACK_SIZE)));
}
#endif	MACH_ASSERT


/*
 *	export a routine that can be called to range check the
 *	the current stack pointer against current_thread()->kernel_stack.
 */
int	stack_assert_red = 1024;
boolean_t stack_assert_bounds()
{
	vm_offset_t	stack;
	int		insp;

	if ((stack = current_stack()) != 0) {
		assert((vm_offset_t) &insp > (stack + stack_assert_red));
		assert((vm_offset_t) &insp < (stack + KERNEL_STACK_SIZE));
		return  ((vm_offset_t) &insp > (stack + stack_assert_red)) &&
			((vm_offset_t) &insp < (stack + KERNEL_STACK_SIZE));
	}
	return TRUE;
}



#if	PREFAULT_PC
/*
 *	XXX WORKAROUND:
 *	XXX
 *	XXX Read the instruction at (fir - 4) to prefault
 *	XXX in the text if needed.
 */
void i860_prefault_pc(regs)
	register struct i860_saved_state *regs;
{
	unsigned int	instruction;

	copyin(regs->pc - 4, &instruction, sizeof(unsigned int));
}
#endif	/* PREFAULT_PC */


/*
 *	switch_context:
 *
 *	Resumes the new thread on its preserved kernel stack.
 *	This call changes address spaces if necessary.  If a
 *	continuation for the thread is supplied, then switch_context()
 *	does not save registers and does not return.  Otherwise,
 *	switch_context() saves the current thread's register state
 *	and kernel stack and returns when the calling thread is
 *	rescheduled, returning the previously running thread.
 */
thread_t switch_context(old, continuation, new)
	register thread_t	old;
	void (*continuation)();
	register thread_t	new;
{
	register struct i860_kernel_state *newks, *oldks;
	extern thread_t	i860_context_switch();
	thread_act_t old_act = old->top_act;
	thread_act_t new_act = new->top_act;

	assert(get_spl() > 0);

#if	INTERRUPT_DEBUG
	assert(interrupt_nesting_level[cpu_number()] == 0);
#endif	/* INTERRUPT_DEBUG */

	assert(new->kernel_stack != (vm_offset_t) 0);
	assert(old->kernel_stack != (vm_offset_t) 0);

	assert(old_act == current_act());
	assert(old->kernel_stack == current_stack());

#if	MACH_ASSERT
	if (watchacts & WA_SWITCH)
		printf("\tswitch_context(old=%x con=%x new=%x)\n",
					    old, continuation, new);
#endif	/* MACH_ASSERT */

#if	0 /* MACH_ASSERT */
	{
		int	dummy;

		if (!inrange(&dummy, current_stack())) {
			printf("switch_context(old=0x%x,cont=0x%x,new=0x%x):\n",
				old, continuation, new);
			printf("&dummy = 0x%x\n", &dummy);
			printf("[0x%x to 0x%x]\n",
				current_stack(),
				current_stack() + KERNEL_STACK_SIZE);
			assert(0);
		}
	}
#endif	/* MACH_ASSERT */

	oldks = STACK_IKS(old->kernel_stack);
	newks = STACK_IKS(new->kernel_stack);
#if	PARANOIDPCB
	assert(oldks->ks_r0 == (unsigned) old);
	assert(newks->ks_r0 == (unsigned) new);
#endif	PARANOIDPCB
	assert(inrange(newks->ks_sp, new->kernel_stack));

	old->continuation = continuation;

#if	INTERRUPT_DEBUG
	assert(interrupt_nesting_level[cpu_number()] == 0);
#endif	/* INTERRUPT_DEBUG */

	if (old_act->map != new_act->map)
		change_address_space(old_act, new_act);

	INSTALL_THREAD(new);

	switch_log(LOG_SWITCH, old, continuation, new, newks);

#if	INTERRUPT_DEBUG
	assert(interrupt_nesting_level[cpu_number()] == 0);
#endif	/* INTERRUPT_DEBUG */

	return i860_context_switch(newks, continuation, oldks, old);
}


/*
 *	thread_set_syscall_return:
 *
 *	Alter the thread's state so that a following thread_exception_return
 *	will make the thread return 'retval' from a syscall(r16).
 *	Utilized by mach/mach_msg.c; mach_msg_interrupt()
 */
void thread_set_syscall_return(thread, retval)
	thread_t	thread;
	kern_return_t	retval;
{
	register struct i860_saved_state *regs;

	regs = USER_REGS(thread->top_act);
	regs->r16 = retval;
	regs->pc += 4;		/* step past the trap instruction */
}

#if	defined(i860XP) && (NCPUS == 1 || ASMP)
#define	FASTTRAPS	1
#endif	/* defined(i860XP) && (NCPUS == 1 || ASMP) */

/*
 *	thread_syscall_return:
 *
 *	Calls the current thread's user system call continuation to make
 *	the thread return to user space from a system call with the
 *	specified return value.  (Low-level machine-dependent trap code
 *	creates system call continuations).
 */
void thread_syscall_return(retval)
kern_return_t	retval;
{
	thread_act_t	thr_act;
	vm_offset_t	stack;
	int		s;
	register struct i860_saved_state *regs;
	extern void	i860_syscall_return();
#if	FASTTRAPS
	extern void	fast_syscall_continue();
#endif	FASTTRAPS

	RELEASE_MASTER_CPU();

#if	PARANOIDPCB
	s = sploff();
#endif	PARANOIDPCB
	thr_act = current_act();
	stack = current_stack();
	regs = USER_REGS(thr_act);
#if	PARANOIDPCB
	splon(s);
#endif	PARANOIDPCB

#if	PARAGON860
	baton_exit();
#endif	PARAGON860

	/*
	 * Alter the thread's state so that a following thread_exception_return
	 * will make the thread return 'retval' from a syscall.
	 * call to thread_set_syscall_return() removed and code copied here.
	 */
	regs->r16 = retval;
	regs->pc += 4;		/* step past the trap instruction */

#if	PREFAULT_PC
	i860_prefault_pc(regs);
#endif	PREFAULT_PC

	assert((regs->psr & (PSR_PU|PSR_PIM)) == (PSR_PU|PSR_PIM));

	if (flush_on_syscall_return) flush();

	switch_log(LOG_SYSCALLRET, thr_act->thread, 0, 0, 0);

#if	FASTTRAPS
	i860_call_continuation_new(fast_syscall_continue, TOPOF(stack), regs);
#else	FASTTRAPS
	i860_call_continuation_new(i860_syscall_return, TOPOF(stack), regs);
#endif	FASTTRAPS
	/*NOTREACHED*/
}


/*
 *	thread_exception_return:
 *
 *	Calls the current thread's user exception continuation to make
 *	the thread return to user space from an exception or page-fault.
 *	(Low-level machine-dependent trap code creates exception
 *	continuations).
 */
void thread_exception_return()
{
	thread_act_t	thr_act;
	vm_offset_t	stack;
	int		s;
	struct i860_saved_state *regs;
	extern void	i860_exception_return();

	RELEASE_MASTER_CPU();

#if	PARANOIDPCB
	s = sploff();
#endif	PARANOIDPCB
	thr_act = current_act();
	stack = current_stack();
	regs = USER_REGS(thr_act);
#if	PARANOIDPCB
	splon(s);
#endif	PARANOIDPCB

#if	PREFAULT_PC
	i860_prefault_pc(regs);
#endif	PREFAULT_PC

	assert((regs->psr & (PSR_PU|PSR_PIM)) == (PSR_PU|PSR_PIM));

#if	i860XP
	/*
	 *	Make sure that the instructions that may be lingering
	 *	in the data cache make it out to memory.
	 */
	if ((regs->psr & PSR_IAT) != 0) {
		flush();
	} else
#endif	i860XP
	if (flush_on_exception_return) {
		flush();
	}

	switch_log(LOG_EXCEPTRET, thr_act->thread, 0, 0, 0);

	i860_call_continuation_new(i860_exception_return, TOPOF(stack), regs);
	/*NOTREACHED*/
}

/*
 *	thread_ctrap_return:
 *
 *	Calls the current thread's user exception continuation to make
 *	the thread return to user space from an exception or page-fault.
 *	(Low-level machine-dependent trap code creates exception
 *	continuations).
 */

void thread_ctrap_return()
{
	thread_act_t	thr_act;
	vm_offset_t	stack;
	int		s;
	struct i860_saved_state *regs;
	extern void	i860_exception_return();

#ifdef	DEAD_CODE
	/* we don't have the baton here,
	 * and the thread_block() under release_master_cpu()
	 * would require it
	 * sorry about that, you stay bound
	 */
	RELEASE_MASTER_CPU();
#endif	DEAD_CODE

#if	PARANOIDPCB
	s = sploff();
#endif	PARANOIDPCB
	thr_act = current_act();
	stack = current_stack();
	assert(thr_act->mact.pcb != 0);
	regs = USER_REGS(thr_act);
#if	PARANOIDPCB
	splon(s);
#endif	PARANOIDPCB

#if	PREFAULT_PC
	i860_prefault_pc(regs);
#endif	PREFAULT_PC

	assert((regs->psr & (PSR_PU|PSR_PIM)) == (PSR_PU|PSR_PIM));

#if	i860XP
	/*
	 *	Make sure that the instructions that may be lingering
	 *	in the data cache make it out to memory.
	 */
	if ((regs->psr & PSR_IAT) != 0) {
		flush();
	} else
#endif	i860XP
	if (flush_on_exception_return) {
		flush();
	}

	switch_log(LOG_EXCEPTRET, thr_act->thread, 0, 0, 0);

	i860_call_continuation_new(i860_exception_return, TOPOF(stack), regs);
	/*NOTREACHED*/
}


void thread_bootstrap_return()
{
	thread_act_t	thr_act;
	vm_offset_t	stack;
	int		s;
	register struct i860_saved_state *regs;
	extern void	i860_bootstrap_return();

	RELEASE_MASTER_CPU();

#if	PARANOIDPCB
	s = sploff();
#endif	PARANOIDPCB
	thr_act = current_act();
	stack = current_stack();
	regs = USER_REGS(thr_act);
#if	PARANOIDPCB
	splon(s);
#endif	PARANOIDPCB

#if	PARAGON860
	baton_exit();
#endif	PARAGON860

#if	PREFAULT_PC
	i860_prefault_pc(regs);
#endif	PREFAULT_PC

	/* make sure we are going back to user mode with interrupts enabled */
	assert((regs->psr & (PSR_PU|PSR_PIM)) == (PSR_PU|PSR_PIM));

	if (flush_on_bootstrap_return) flush();

	switch_log(LOG_BOOTRET, thr_act->thread, 0, 0, 0);

	i860_call_continuation_new(i860_bootstrap_return, TOPOF(stack), regs);
	/*NOTREACHED*/
}


#define	FIXED_PGC_COMPILER	0
#if	!FIXED_PGC_COMPILER
/*
 *	PGI's optimizer generates incorrect code when
 *	the macro's are expanded inline but works okay
 *	when they're inside a subroutine call.
 */
void change_pmaps(opmap, oth, npmap, nth)
	register pmap_t		opmap, npmap;	/* old, new */
	register thread_act_t	oth, nth;	/* old, new */
{
	register int	cpu = cpu_number();

#if	OSF_INTEL
	PMAP_DEACTIVATE_USER(oth, cpu);
	PMAP_ACTIVATE_USER(nth, cpu);
#else	/* OSF_INTEL */
	PMAP_DEACTIVATE_USER(opmap, oth, cpu);
	PMAP_ACTIVATE_USER(npmap, nth, cpu);
#endif	/* OSF_INTEL */
}
#endif	!FIXED_PGC_COMPILER


/*
 *	change_address_space:
 *
 *	Perform pmap invalidation if switching tasks.
 */

void change_address_space(
	register thread_act_t	old,
	register thread_act_t	new)
{
	if (old->map != new->map) {

		/*
		 * if same physical map (pmap) then skip the needless change
		 */
		if ( vm_map_pmap(old->map) == vm_map_pmap(new->map) )
			return;

#if	FIXED_PGC_COMPILER

		{ register int	cpu = cpu_number();

#if	OSF_INTEL
		PMAP_DEACTIVATE_USER(old, cpu);
		PMAP_ACTIVATE_USER(new, cpu);
#else	/* OSF_INTEL */
		PMAP_DEACTIVATE_USER(vm_map_pmap(old_task->map), old, cpu);
		PMAP_ACTIVATE_USER(vm_map_pmap(new_task->map), new, cpu);
#endif	/* OSF_INTEL */
		}

#else	FIXED_PGC_COMPILER 

		change_pmaps( vm_map_pmap(old->map), old,
			      vm_map_pmap(new->map), new);

#endif	FIXED_PGC_COMPILER

	}
}

#if	OSF_INTEL

/*
 * consider_machine_collect:
 *
 *	Try to collect machine-dependent pages
 */
void
consider_machine_collect()
{
}

/*
 *	machine_kernel_stack_init()
 *
 *	Initialize a kernel stack which has already been
 *	attached to its thread_activation.
 */
void machine_kernel_stack_init(thread, continuation)
	thread_t	thread;
	void		(*continuation)();
{
	register struct i860_kernel_state *ks;
	thread_act_t	thr_act = thread->top_act;
	vm_offset_t	stack;

	assert(thr_act);
	stack = thread->kernel_stack;
	assert(stack != (vm_offset_t) 0);

	assert(continuation != (void (*)()) 0);

#if	MACH_ASSERT
	{
		int		dummy;
		static int	inrange();

		if (current_stack() && !inrange(&dummy, current_stack())) {
			printf("stack_attach(th=0x%x,stack=0x%x,cont=0x%x):\n",
				thread, stack, continuation);
			printf("&dummy = 0x%x\n", &dummy);
			printf("[0x%x to 0x%x]\n",
				current_stack(),
				current_stack() + KERNEL_STACK_SIZE);
			assert(0);
		}
	}
#endif	MACH_ASSERT

	ks = STACK_IKS(stack);

#if	PARANOIDPCB
	ks->ks_r0 = (unsigned) thread;
#endif	PARANOIDPCB

	ks->ks_r1 = (unsigned) continuation;
	ks->ks_sp = (unsigned) TOPOF(stack);
	ks->ks_fp = 0;

	STACK_IEL(stack)->eframe = USER_REGS(thread->top_act);
}

/*
 * Initialize the machine-dependent state for a new thread.
 */
kern_return_t
thread_machine_create(thread_t thread, thread_act_t thr_act, void (*start_pos)(void))
{
#if	MACH_ASSERT
	if (watchacts & WA_PCB)
		printf("thread_machine_create(thr=%x,thr_act=%x,st=%x)\n",
			thread, thr_act, start_pos);
#endif	/* MACH_ASSERT */

        assert(thread != NULL);
        assert(thr_act != NULL);

        /*
         *      Allocate a kernel stack per shuttle
         */
        thread->kernel_stack = (int)stack_alloc();
        assert(thread->kernel_stack != 0);

        /*
         *      Point top of kernel stack to user's registers.
         */
	STACK_IEL(thread->kernel_stack)->eframe = USER_REGS(thr_act);

	/*
	 * Utah code fiddles with pcb here - (we don't need to)
	 */
	return(KERN_SUCCESS);
}

/*
 * Machine-dependent cleanup prior to destroying a thread
 */
void
thread_machine_destroy( thread_t thread )
{
        spl_t s;

        assert(thread->kernel_stack != 0);

        s = splsched();
        stack_free(thread->kernel_stack);
        splx(s);
}

/*
 * This is used to set the current thr_act/thread
 * when starting up a new processor
 */
void
thread_machine_set_current( thread_t thread )
{
	INSTALL_THREAD(thread);
}

/*
 * Perform machine-dependent per-thread initializations
 */
void
thread_machine_init(
	void)
{
}

void act_machine_init()
{
	int i;
	thread_act_t thr_act;

#if	MACH_ASSERT
	if (watchacts & WA_PCB)
		printf("act_machine_init()\n");
#endif	/* MACH_ASSERT */

	assert(THREAD_MACHINE_STATE_MAX <= THREAD_STATE_MAX);

	/*
	 * If we start using kernel activations,
	 * would normally create kernel_thread_pool here,
	 * populating it from the act_zone
	 */
}

kern_return_t
act_machine_create(task_t task, thread_act_t thr_act)
{
	MachineThrAct_t mact = &thr_act->mact;
	pcb_t pcb;

#if	MACH_ASSERT
	if (watchacts & WA_PCB)
		printf("act_machine_create(task=%x,thr_act=%x) pcb=%x\n",
			task,thr_act, mact->pcbbuf);
#endif	/* MACH_ASSERT */

	/*
	 * Clear & Init the pcb
	 */
	pcb_init(thr_act);

	return KERN_SUCCESS;
}

kern_return_t
act_create_kernel(
	task_t		task, 
	vm_offset_t	stack,
	vm_size_t	stack_size,
	thread_act_t	*out_act)
{
	int rc;

#if	MACH_ASSERT
	if (watchacts & WA_PCB)
		printf("act_create_kernel(task=%x,stk=%x,&thr_act=%x)\n",
				task, stack, out_act);
#endif	/* MACH_ASSERT */

	rc = act_create(task, stack, stack_size, out_act);
	return rc;
}

void
act_machine_destroy(thread_act_t thr_act)
{
#if	MACH_ASSERT
	if (watchacts & WA_PCB)
		printf("act_machine_destroy(0x%x)\n", thr_act);
#endif	/* MACH_ASSERT */

	pcb_terminate(thr_act);
}

void
act_machine_return(int code)
{
	thread_act_t thr_act = current_act();

#if	MACH_ASSERT
	/*
	* We don't go through the locking dance here needed to
	* acquire thr_act->thread safely.
	*/

	if (watchacts & WA_EXIT)
		printf("act_machine_return(0x%x) cur_act=%x(%d) thr=%x(%d)\n",
			code, thr_act, thr_act->ref_count,
			thr_act->thread, thr_act->thread
					? thr_act->thread->ref_count : 0);
#endif	/* MACH_ASSERT */

	/*
	 * XXXX the following is wrong:
	 *	(1) we aren't yet using kernel activations
	 *	(2) need to keep the thread ref for the reaper
	 */
	/* act_deallocate(thr_act);	* XXX thread reference */
	/* act_deallocate(thr_act);	* XXX kernel activation reference */
	thread_terminate_self();
	/*NOTREACHED*/
	panic("act_machine_return: TALKING ZOMBIE!");
}

int switch_act_swapins = 0;

/*
 * machine_switch_act
 *
 * Machine-dependent details of activation switching.  Called with
 * RPC locks held and preemption disabled.
 */
void
machine_switch_act( 
	thread_t	thread,
	thread_act_t	old,
	thread_act_t	new,
	unsigned	cpu)
{
	MACHINE_STACK_STASH(new->thread->kernel_stack);
	ast_context(new, cpu);

	change_address_space(old, new);

	active_stacks[cpu] = new->thread->kernel_stack;
	kernel_stack[cpu] = TOPOF(new->thread->kernel_stack);

	STACK_IEL(stack)->eframe = USER_REGS(new);

	switch_log(LOG_HANDOFF, old, 0, new, 0);
}

/*
 * Flush out lazily evaluated hardware state in the owning thread's
 * context before termination.
 *
 * N.B.
 *	Using flush() is a heavy weight operation, but I believe
 *	what is called for is to dispose of cached state, which
 *	is why we only do it if there is more than 1 CPU.
 */
void
thread_machine_flush()
{
#if	NCPUS > 1
	flush();
#endif	/* NCPUS > 1 */
}

#endif	OSF_INTEL

/*
 *	Initialize the pcb zone
 *
 *	We enforce a 16-byte alignment restriction on every pcb
 *	as that will permit fst.q and friends when saving and
 *	restoring context.
 *
 *	Mark the zone collectable so in a memory crunch, we return
 *	unused pcb's to the zone.
 */
void pcb_module_init()
{
	/*
	 * No pcb_zone any more -- now part of machine-dependent
	 * thread_activation.
	 */
}

#if 0

zone_t pcb_zone;

pcb_t pcb_free_list;		/* list of unused pcb structures */
unsigned int pcb_free_count;	/* size of the list, for debugging */

/*
 *	Allocate a pcb.
 *
 *	Try the free list first, then try the zone.  Always check
 *	the alignment...
 */
pcb_t pcb_alloc()
{
	register pcb_t	pcb;

	if ((pcb = pcb_free_list) != 0) {
		pcb_free_list = *((pcb_t *)pcb);
		pcb_free_count--;
		if ((int) pcb & (PCB_ALIGNMENT-1))
			panic("pcb_alloc: misaligned pcb on free list");
		return pcb;
	}

	pcb = (pcb_t) zalloc(pcb_zone);
	if (pcb == 0)
		panic("pcb_alloc");
	if ((int) pcb & (PCB_ALIGNMENT-1))
		panic("pcb_alloc: misaligned pcb returned from zalloc");

	return pcb;

}


/*
 *	Return a pcb to the free list.
 */
void pcb_free(pcb)
	register pcb_t	pcb;
{
	pcb_free_count++;
	*((pcb_t *) pcb) = pcb_free_list;
	pcb_free_list = pcb;
}

#endif	/* 0 */

/*
 *	Initialize a pcb for a thread.
 */
void pcb_init(
	register thread_act_t	thr_act)
{
	register unsigned int	pcbbuf;
	register pcb_t		pcb;

	assert(thr_act->mact.pcb == (pcb_t)0);
	pcbbuf = (unsigned int)thr_act->mact.pcbbuf;
	pcbbuf = (pcbbuf + (PCB_ALIGNMENT - 1)) & ~(PCB_ALIGNMENT - 1);

	thr_act->mact.pcb = (pcb_t)pcbbuf;
	pcb = thr_act->mact.pcb;

	/*
	 *	We can't let random values leak out to the user.
	 */
	bzero((char *) pcb, sizeof *pcb);

	/*
	 *	Make the thread run in user mode,
	 *	if it ever comes back out of the kernel.
	 */
	pcb->i860ss.psr = PSR_PU | PSR_PIM | PSR_IM;
	pcb->i860ss.pc = 0;	/* set to 0 to stop stack backtrace */

	pcb->i860ss.fsr = FSR_FTE; /* enable floating Point traps */
	pcb->ieee_status = IEEE_MASKS;
	pcb->flags = PCB_IEEE_FP | PCB_SIGNAL_PFLDQ;

	/*
	 *	Default (initial) setting for misaligned accesses.
	 */
	if (i860_misalignment_policy)
		pcb->flags |= PCB_SIGNAL_MA;
	else
		pcb->flags &= ~PCB_SIGNAL_MA;

}

/*
 * Adjust saved register state for thread belonging to task
 * created with kernel_task_create().
 */
void
pcb_user_to_kernel(
        pcb_t           pcb)
{
	pcb->i860ss.psr &= ~PSR_PU;
}

/*
 *	Terminate a thread's pcb.
 *
 *	Return the pcb to the free list, and unlink the
 *	pcb from the thread.
 */
void pcb_terminate(
	register thread_act_t thr_act)
{
	thr_act->mact.pcb = (pcb_t)0;
}


/*
 *	pcb_collect:
 *
 *	Attempt to free excess pcb memory.
 */

void pcb_collect(thread)
	thread_t thread;
{
#if 0
	register pcb_t	pcb;

	while (pcb_free_count > 0) {
		pcb = pcb_free_list;
		pcb_free_list = *((pcb_t *)pcb);
		pcb_free_count--;
		zfree(pcb_zone, (vm_offset_t) pcb);
	}
#endif	/* 0 */
}


/*
 *	thread_setstatus:
 *
 *	Set the status of the given thread.
 */

kern_return_t act_machine_set_state(
	thread_act_t		thr_act,
	thread_flavor_t		flavor,
	thread_state_t		tstate,
	mach_msg_type_number_t	count)
{
	int	kernel_act = thr_act->kernel_loading || thr_act->kernel_loaded;

	switch (flavor) {
	case THREAD_SYSCALL_STATE: {
		register struct i860_saved_state *i860ss;
		register struct thread_syscall_state *state;

		i860ss = USER_REGS(thr_act);
		state = (struct thread_syscall_state *) tstate;
		bzero((char *)i860ss, sizeof(struct i860_saved_state));

		i860ss->pc = state->pc;
		i860ss->sp = state->sp;
		      
		/*
		 *  Slam good values into control registers
		 */
		i860ss->psr = PSR_PU | PSR_PIM;
		i860ss->epsr = get_epsr();

		break;
	}

	case i860_THREAD_STATE: {
		register struct i860_saved_state *i860ss;
		register struct i860_thread_state *state;

		if (count != i860_THREAD_STATE_COUNT)
			return(KERN_INVALID_ARGUMENT);

		i860ss = USER_REGS(thr_act);
		state = (struct i860_thread_state *) tstate;

		bcopy((const char *)&state->r0,
		      (char *)&i860ss->r0,
		      64 * sizeof(int) );

		/*
		 * XXX bcopy() is used below because the alignment of
		 * XXX "state" may not be trusted (although it seems to
		 * XXX be 4-byte aligned...).
		 *
		 * XXX If i860/thread.h and mach/i860/thread_status.h
		 * XXX matched, none of this would be a problem.
		 */

		/* 3 stage load pipe */
		bcopy((const char *)&state->psv_l1[0],
		      (char *)&i860ss->psv_l1[0],
		      6*sizeof(double));

		/* 3 stage adder pipe */
		bcopy((const char *)&state->psv_a1,
		      (char *)&i860ss->psv_a1,
		      3 * sizeof(double));

		/* 3 stage multiplier pipe */
		bcopy((const char *)&state->psv_m1,
		      (char *)&i860ss->psv_m1,
		      3 * sizeof(double));

		/* 1 stage interpolator(?) pipe */
		bcopy((const char *)&state->psv_i1,
		      (char *)&i860ss->psv_i1,
		      1 * sizeof(double));

		/* T, KR, KI, merge */
		bcopy((const char *)&state->spc_t,
		      (char *)&i860ss->spc_t,
		      sizeof(double));
		bcopy((const char *)&state->spc_ki,
		      (char *)&i860ss->spc_ki,
		      sizeof(double));
		bcopy((const char *)&state->spc_kr,
		      (char *)&i860ss->spc_kr,
		      sizeof(double));
		bcopy((const char *)&state->spc_merge,
		      (char *)&i860ss->spc_merge,
		      sizeof(double));

		/* 3 stages of fsr */
		i860ss->fsr1 = state->fsr1;
		i860ss->fsr2 = state->fsr2;
		i860ss->fsr = state->fsr;

		/* other special registers of interest */
		i860ss->pc = state->pc;
		if (kernel_act)
			i860ss->psr = state->psr;
		else
			i860ss->psr = state->psr | (PSR_PU|PSR_PIM);
		i860ss->epsr = state->epsr;
		i860ss->db = state->db;

		/* FPE handler values */
		i860ss->trapped_opcode = state->fpe_trapped_op;
		i860ss->rdest = state->fpe_rdest;
		i860ss->src1 = state->fpe_src1;
#if	FIXED_SERVER_IEEE_STATUS
		thr_act->mact.pcb->ieee_status = state->fpe_ieee_status;
#endif	FIXED_SERVER_IEEE_STATUS
		bcopy((const char *)&state->fp1,
		      (char *)&i860ss->fp1,
		      4 * sizeof(double));

		break;
	}

	case i860_SAVED_STATE: {
		register struct i860_saved_state *i860ss;
		register struct i860_saved_state *state;

		if (count != i860_SAVED_STATE_COUNT)
			return(KERN_INVALID_ARGUMENT);

		i860ss = USER_REGS(thr_act);
		state = (struct i860_saved_state *) tstate;

		bcopy((const char *)state,
		      (char *)i860ss,
		      sizeof(struct i860_saved_state));

		/* special registers requiring hand processing */
		if (kernel_act)
			i860ss->psr = state->psr;
		else
			i860ss->psr = state->psr | (PSR_PU|PSR_PIM);

#if	FIXED_SERVER_IEEE_STATUS
		thr_act->mact.pcb->ieee_status = state->fpe_ieee_status;
#endif	FIXED_SERVER_IEEE_STATUS
		break;
	}
	default:
		return (KERN_INVALID_ARGUMENT);
	}

	return(KERN_SUCCESS);
}


/*
 *	thread_getstatus:
 *
 *	Get the status of the specified thread.
 */

kern_return_t act_machine_get_state(
	register thread_act_t	thr_act,
	thread_flavor_t		flavor,
	thread_state_t		tstate,
	mach_msg_type_number_t	*count)
{
	switch (flavor) {
	case THREAD_STATE_FLAVOR_LIST:
		if (*count < 1)
			return (KERN_INVALID_ARGUMENT);

		tstate[0] = i860_THREAD_STATE;
		*count = 1;
		break;

	case i860_THREAD_STATE: {
		register struct i860_saved_state *i860ss;
		register struct i860_thread_state *state;

		if (*count < i860_THREAD_STATE_COUNT)
			return(KERN_INVALID_ARGUMENT);

		i860ss = (struct i860_saved_state *)USER_REGS(thr_act);
		state = (struct i860_thread_state *) tstate;

		bcopy((const char *)&i860ss->r0,
		      (char *)&state->r0,
		      64 * sizeof(int) );

		/*
		 * XXX bcopy() is used below because the alignment of
		 * XXX "state" may not be trusted (although it seems to
		 * XXX be 4-byte aligned...).
		 *
		 * XXX If i860/thread.h and mach/i860/thread_status.h
		 * XXX matched, none of this would be a problem.
		 */

		/* 3 stage load pipe */
		bcopy((const char *)&i860ss->psv_l1[0],
		      (char *)&state->psv_l1[0],
		      6*sizeof(double));

		/* 3 stage adder pipe */
		bcopy((const char *)&i860ss->psv_a1,
		      (char *)&state->psv_a1,
		      3 * sizeof(double));

		/* 3 stage multiplier pipe */
		bcopy((const char *)&i860ss->psv_m1,
		      (char *)&state->psv_m1,
		      3 * sizeof(double));

		/* 1 stage interpolator(?) pipe */
		bcopy((const char *)&i860ss->psv_i1,
		      (char *)&state->psv_i1,
		      1 * sizeof(double));

		/* T, KR, KI, merge */
		bcopy((const char *)&i860ss->spc_t,
		      (char *)&state->spc_t,
		      sizeof(double));
		bcopy((const char *)&i860ss->spc_ki,
		      (char *)&state->spc_ki,
		      sizeof(double));
		bcopy((const char *)&i860ss->spc_kr,
		      (char *)&state->spc_kr,
		      sizeof(double));
		bcopy((const char *)&i860ss->spc_merge,
		      (char *)&state->spc_merge,
		      sizeof(double));

		/* 3 stages of fsr */
		state->fsr1 = i860ss->fsr1;
		state->fsr2 = i860ss->fsr2;
		state->fsr = i860ss->fsr;

		/* other special registers of interest */
		state->pc = i860ss->pc;
		state->psr = i860ss->psr;
		state->epsr = i860ss->epsr;
		state->db = i860ss->db;

		/* FPE handler values */
		state->fpe_trapped_op = i860ss->trapped_opcode;
		state->fpe_rdest = i860ss->rdest;
		state->fpe_src1 = i860ss->src1;
		state->fpe_ieee_status = thr_act->mact.pcb->ieee_status;
		bcopy((const char *)&i860ss->fp1,
		      (char *)&state->fp1,
		      4 * sizeof(double));

		*count = i860_THREAD_STATE_COUNT;
		break;
	}

	case i860_SAVED_STATE: {
		register struct i860_saved_state *i860ss;
		register struct i860_saved_state *state;

		if (*count < i860_SAVED_STATE_COUNT)
			return(KERN_INVALID_ARGUMENT);

		i860ss = USER_REGS(thr_act);
		state = (struct i860_saved_state *) tstate;

		bcopy((const char *)i860ss,
		      (char *)state,
		      sizeof(struct i860_saved_state));

		*count = i860_SAVED_STATE_COUNT;
		break;
	}

	default:
		*count = 0;
		return (KERN_INVALID_ARGUMENT);
	}

	return (KERN_SUCCESS);
}


#if	SWITCH_HISTORY
static char *stateof(s)
int	s;
{
	static char	buf[16];
	char	*p = buf;

	*p++ = (s & TH_WAIT)    ? 'w' : '.';
	*p++ = (s & TH_SUSP)    ? 's' : '.';
	*p++ = (s & TH_RUN)     ? 'r' : '.';
	*p++ = (s & TH_UNINT)   ? 'u' : '.';
	*p++ = (s & TH_HALTED)  ? 'h' : '.';
	*p++ = (s & TH_IDLE)    ? 'i' : '.';
	*p++ = (s & TH_STACK_HANDOFF) ? 'O' : '.';
#if     THREAD_SWAPPER
	*p++ = (s & TH_SW_COMING_IN) ? 'I' : '.';
#endif	/* THREAD_SWAPPER */

	return buf;
}


static char *logmethod(n)
int	n;
{
	switch (n) {
	case LOG_SWITCH:
		return "swit";

	case LOG_HANDOFF:
		return "hand";

	case LOG_ATTACH:
		return "atch";

	case LOG_CONTINUE:
		return "cont";

	case LOG_DETACH:
		return "dtch";

	case LOG_SYSCALLRET:
		return "usys";

	case LOG_EXCEPTRET:
		return "uexc";

	case LOG_BOOTRET:
		return "boot";
	}
	return "????";
}


void db_show_switch_hist()
{
	int	i, j;
	struct switch_history *sh;

	db_printf("  nth sw  nth trap   nth ast  what  cur thread   cur stack\n");

	j = switch_history_next - 1;
	for (i = 0; i < SWITCH_HISTLEN; i++) {

		if (j < 0)
			j = SWITCH_HISTLEN - 1;

		sh = &switch_history[j];

		db_printf("%8u  %8u  %8u  %4s  0x%08x  0x%08x\n",
			sh->sh_nth,
			sh->sh_trapn,
			sh->sh_astn,
			logmethod(sh->sh_flag),
			sh->sh_curact,
			sh->sh_cursp);

		switch (sh->sh_flag) {
		case LOG_HANDOFF:
		case LOG_ATTACH:
		case LOG_DETACH:
		case LOG_CONTINUE:
		case LOG_SWITCH:
			db_printf("\told=0x%x [kstak=0x%08x state=%s]\n",
				sh->sh_old,
				sh->sh_old_kstack,
				stateof(sh->sh_old_state));
			if ((sh->sh_flag != LOG_DETACH) &&
			    (sh->sh_flag != LOG_HANDOFF)) {
				db_printf("\tcont[0x%08x]=", sh->sh_cont);
				if (sh->sh_cont) {
					db_printsym((db_expr_t)sh->sh_cont,
						    DB_STGY_ANY);
				}
			}
			db_printf("\n");
			if (sh->sh_new) {
				db_printf("\t");
				db_printf("new=0x%x [kstak=0x%08x state=%s]\n",
					sh->sh_new,
					sh->sh_new_kstack,
					stateof(sh->sh_new_state));
				if ((sh->sh_flag == LOG_SWITCH) ||
				    (sh->sh_flag == LOG_ATTACH)) {
					db_printf("\t    [sp=0x%x fp=0x%x r1[0x%x]=",
						sh->sh_sp,
						sh->sh_fp,
						sh->sh_r1);
					db_printsym(sh->sh_r1, DB_STGY_ANY);
					db_printf("]\n");
				}
			}
			break;

		case LOG_SYSCALLRET:
		case LOG_EXCEPTRET:
		case LOG_BOOTRET:
			break;
		}
		j--;
		db_printf("\n");
	}
}
#endif	SWITCH_HISTORY

#if	OSF_INTEL
/*
 * Allocate argument area and set registers for first user thread.
 */
vm_offset_t
set_user_regs(
	vm_offset_t	stack_base,	/* low address */
	vm_offset_t	stack_size,
	int		*entry,
	vm_size_t	arg_size)
{
	vm_offset_t	arg_addr;
	register struct i860_saved_state *saved_state;

	arg_size = (arg_size + sizeof(double) - 1) & ~(sizeof(double)-1);
	arg_addr = stack_base + stack_size - arg_size;

	saved_state = USER_REGS(current_act());
	saved_state->sp = (int)arg_addr;
	saved_state->pc = entry[0];

	return (arg_addr);
}

/*
 * Return preferred address of user stack.
 * Always returns low address.  If stack grows up,
 * the stack grows away from this address;
 * if stack grows down, the stack grows towards this
 * address.
 */
vm_offset_t
user_stack_low(
	vm_size_t	stack_size)
{
	return (VM_MAX_ADDRESS - stack_size);
}


#if	MACH_KDB
/*
 * Some routines for debugging activation code
 */
static void	dump_handlers(thread_act_t);
static void	dump_regs(thread_act_t);

static void
dump_handlers(thread_act_t thr_act)
{
    ReturnHandler *rhp = thr_act->handlers;
    int	counter = 0;

    printf("\t");
    while (rhp) {
	if (rhp == &thr_act->special_handler){
	    if (rhp->next)
		printf("[NON-Zero next ptr(%x)]", rhp->next);
	    printf("special_handler()->");
	    break;
	}
	printf("hdlr_%d(%x)->",counter,rhp->handler);
	rhp = rhp->next;
	if (++counter > 32) {
		printf("Aborting: HUGE handler chain\n");
		break;
	}
    }
    printf("HLDR_NULL\n");
}

int
dump_act(thread_act_t thr_act)
{
	struct i860_exception_link	*el;
	struct i860_kernel_state	*ks;
	struct i860_saved_state		*ss;

	if (!thr_act)
		return(0);
	db_printf("thr_act(0x%x)(%d): thread=%x(%d) task=%x(%d)\n",
	       thr_act, thr_act->ref_count,
	       thr_act->thread, thr_act->thread ? thr_act->thread->ref_count:0,
	       thr_act->task,   thr_act->task   ? thr_act->task->ref_count : 0);

	if (thr_act->pool_port) {
	    thread_pool_t actpp = &thr_act->pool_port->ip_thread_pool;
	    db_printf("\tpool(acts_p=%x, waiting=%d) pool_next %x\n",
		actpp->thr_acts, actpp->waiting, thr_act->thread_pool_next);
	}else
	    db_printf("\tno thread_pool\n");

	db_printf("\talerts=%x mask=%x susp=%d user_stop=%d active=%x ast=%x\n",
		       thr_act->alerts, thr_act->alert_mask,
		       thr_act->suspend_count, thr_act->user_stop_count,
		       thr_act->active, thr_act->ast);
	db_printf("\thi=%x lo=%x\n", thr_act->higher, thr_act->lower);
	db_printf("\tpcb=%x, ustk=%x\n",
		       thr_act->mact.pcb, thr_act->user_stack);

	if (thr_act->thread && thr_act->thread->kernel_stack) {
	    vm_offset_t stack = thr_act->thread->kernel_stack;

	    db_printf("\tk_stk %x\n", stack);
	}

	dump_handlers(thr_act);
	db_print_thread_pcb(thr_act);
	return((int)thr_act);
}

void
db_dump_pcb(
	struct i860_saved_state *regs)
{
	int *p, c;
	int total = sizeof (*regs) / sizeof (int);

	p = (int *)regs;
	db_printf("PCB:");
	for (c = 0; c < total; ++c) {
		db_printf("\t%8x", p[c]);
		if ((c % 4) == 3)
			db_printf("\n");
	}
	db_printf("\n");
}

#endif	/* MACH_KDB */
#endif	/* OSF_INTEL */
